#ifndef __KLIB_CLISTCTRLSUPPORTCLASS__
#define __KLIB_CLISTCTRLSUPPORTCLASS__


#pragma warning( disable : 4311 )


class CPumpMessage
#ifdef __AFXWIN_H__
	:public CObject
#endif
{
public: // Ƃ肠XbhKvȂقǂ̃}`^XNŖfp̃bZ[Wpvi^XNnj
	// 胂fł͂̎@ł̓VXeG[̌ƂȂB
	// ܂AMFCł́ACObject̔hƂĐ
	void PumpMessage(void){MSG msg; while ( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) 	::SendMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);};
public:
	CPumpMessage(){};
	virtual
		~CPumpMessage(){};
};

class CRadio:public CPumpMessage{
	// STatic Methods
public:
	static CButton*	GetButton(CWnd *pWnd,int nID)		{return ((CButton*)(pWnd->GetDlgItem(nID)));	};
	static void		SetCheck(CWnd *pWnd,int nID,int nStatus){((CButton*)(pWnd->GetDlgItem(nID)))->SetCheck(nStatus);	};
	static int		GetCheck(CWnd *pWnd,int nID)				{return ((CButton*)(pWnd->GetDlgItem(nID)))->GetCheck();	};
	// Dynamic class
private:
	CButton	*pButton;
public:
	void	Attach(CWnd *pParent,int nID)	{pButton=GetButton(pParent,nID); };
	void	SetCheck(int nStatus)			{if(pButton!=NULL)pButton->SetCheck(nStatus);};
	int		GetCheck(void)					{if(pButton!=NULL) return pButton->GetCheck(); else return -1;}
public:
	CRadio(){pButton=NULL;};
	virtual ~CRadio(){};
};

class CListBoxSup:public CPumpMessage{
	//=====================================================================
	// ListBox Control Support runtime

public:
	static DWORD_PTR GetCurrentItemData(CListBox*pList)			{return pList->GetItemData( pList->GetCurSel() );	};
	DWORD_PTR		GetCurrentItemData(void)							{return pListBox->GetItemData( pListBox->GetCurSel() ); };
	long			AddString(CString sString,DWORD dwData,CListBox*pList)	{long d = pList->AddString(sString); pList->SetItemData(d,dwData); return d;		};
	long			AddString(CString sString,DWORD dwData)				{long d = pListBox->AddString(sString); pListBox->SetItemData(d,dwData); return d;};
public:
	BOOL SearchListbox	(LPSTR str,CListBox*pList)	{// LPSTR
		CString s;
		if(pList==NULL)return FALSE;
		long i,n = pList->GetCount();
		for(i=0;i<n;i++){ pList->GetText(i,s); if(strcmpi(s,str)==0){pList->SetCurSel(i); break;} }
		return (i!=n)?FALSE:TRUE; 
	};
	BOOL SearchListbox	(long d,CListBox*pList){	// long
		CString s;
		if(pList==NULL)return FALSE;
		long i,n = pList->GetCount();
		for(i=0;i<n;i++){ pList->GetText(i,s); if(d==atol(s)){pList->SetCurSel(i); break;} }
		return (i!=n)?FALSE:TRUE; 
	};
public:
	BOOL SearchListbox	(CString str,CListBox*pList){return SearchListbox((LPSTR)(LPCTSTR(str)),pList);};
	// attached
public:
	BOOL SearchListbox	(CString str)	{return SearchListbox((LPSTR)(LPCTSTR(str)));};
	BOOL SearchListbox	(LPSTR str)		{return SearchListbox(str,pListBox);};
	BOOL SearchListbox	(long d)		{return SearchListbox(d,pListBox);};
	// local
private:
	CListBox *pListBox;
public:
	void Attach(CListBox *pm_listbox){pListBox = pm_listbox;};
	CListBoxSup(){pListBox=NULL;};
	virtual ~CListBoxSup(){};
};

class CComboBoxSup:public CPumpMessage{
	//=====================================================================
	// ComboBox Control Support runtime
public:
	static void Enable(CComboBox *pCombo,BOOL bEnable)			{pCombo->EnableWindow(bEnable);	};
	static void Enable(CWnd* pParentWnd,int nID,BOOL bEnable)	{(pParentWnd->GetDlgItem(nID))->EnableWindow(bEnable);	};
public:
	static DWORD_PTR	GetCurrentItemData(CComboBox*pCombo)		{return pCombo->GetItemData( pCombo->GetCurSel() );	};
	DWORD_PTR			GetCurrentItemData(void)					{return pComboBox->GetItemData( pComboBox->GetCurSel() );  };
	static void			GetCurrentLBText(CString &sRet,CComboBox*pCombo){pCombo->GetLBText(pCombo->GetCurSel(),sRet);	};
	void				GetCurrentLBText(CString &sRet)					{pComboBox->GetLBText(pComboBox->GetCurSel(),sRet);	};

	long AddString(CString sString,DWORD dwData,CComboBox*pCombo)	{long d = pCombo->AddString(sString); pCombo->SetItemData(d,dwData); return d;		};
	long AddString(CString sString,DWORD dwData)					{long d = pComboBox->AddString(sString); pComboBox->SetItemData(d,dwData); return d;};
public:
	BOOL SearchCombo	(LPSTR str,CComboBox*pCombo){
		CString s;
		if(pCombo==NULL)return FALSE;
		long i,n = pCombo->GetCount();
		for(i=0;i<n;i++){ pCombo->GetLBText(i,s); if(strcmpi(s,str)==0){pCombo->SetCurSel(i); break;} }
		if(i==n)pCombo->SetWindowText(str);
		return (i!=n)?FALSE:TRUE; 
	};
	BOOL SearchCombo	(long d,CComboBox*pCombo){
		CString s;
		if(pCombo==NULL)return FALSE;
		long i,n = pCombo->GetCount();
		for(i=0;i<n;i++){ pCombo->GetLBText(i,s); if(d==atol(s)){pCombo->SetCurSel(i); break;} }
		if(i==n){char str[256]; wsprintf(str,"%d",d); pCombo->SetWindowText(str);}
		return (i!=n)?FALSE:TRUE; 
	};
public:
	BOOL SearchCombo	(CString str,CComboBox*pCombo){return SearchCombo((LPSTR)(LPCTSTR(str)),pCombo);};
	// attached
public:
	BOOL SearchCombo	(CString str)	{return SearchCombo((LPSTR)(LPCTSTR(str)));};
	BOOL SearchCombo	(LPSTR str)		{return SearchCombo(str,pComboBox); };
	BOOL SearchCombo	(long d)		{return SearchCombo(d,pComboBox); };
	// local
private:
	CComboBox *pComboBox;
public:
	void Attach(CComboBox *pm_combobox){pComboBox = pm_combobox;};
	CComboBoxSup(){pComboBox=NULL;};
	virtual ~CComboBoxSup(){pComboBox=NULL;};
};

class CListCtrlSup:public CPumpMessage{
	//=====================================================================
	//=====================================================================
	// data copy
public:
	void CopyOneData(int nAddLine,CListCtrl *srcListCtrl,int nLine){
		CString s[1024];
		long nHeaders;
		nHeaders = GetItemTextArray(nLine,s,srcListCtrl); InsertTextArray(nAddLine,nHeaders,s);
	};
	void CopyAllData(CListCtrl *srcListCtrl){CopyAllHeader(srcListCtrl);	CopyData(srcListCtrl);};
	void CopyData(CListCtrl *srcListCtrl){
		CString s[1024];
		long i,n,nHeaders;
		pListCtrl->DeleteAllItems(); n = srcListCtrl->GetItemCount();
		for(i=0;i<n;i++){nHeaders = GetItemTextArray(i,s,srcListCtrl); InsertTextArray(i,nHeaders,s);}
	};
	void CopyAllData(CListCtrl *srcListCtrl,int nSort,CWnd *pWnd,int nSort2=-1){
		CopyAllHeader(srcListCtrl);
		if(nSort<0)	CopyData(srcListCtrl); else CopyData(srcListCtrl,nSort,pWnd,nSort2);
	};
	void CopyData(CListCtrl *srcListCtrl,int nSort,CWnd *pWnd,int nSort2=-1){
		CString s[1024];
		long i,n,nHeaders;
		pListCtrl->DeleteAllItems();
		n = srcListCtrl->GetItemCount();
		// add index
		CListBox * pListBox = new CListBox;
		RECT rc; ZeroMemory(&rc,sizeof(rc));
		pListBox ->Create(LBS_HASSTRINGS | LBS_SORT,rc,pWnd,(UINT)(pWnd->m_hWnd));
		for(i=0;i<n;i++){
			s[0] = srcListCtrl->GetItemText(i,nSort);
			if(nSort2!=-1){	s[0] += srcListCtrl->GetItemText(i,nSort2);	}
			pListBox ->SetItemData(pListBox ->AddString(s[0]),i);
		}
		// copy data
		for(i=0;i<n;i++){
			int d;
			d = (int)pListBox ->GetItemData(i);
			nHeaders = GetItemTextArray(d,s,srcListCtrl);
			InsertTextArray(i,nHeaders,s);
		}
		delete pListBox;
	};
	//=====================================================================
	// Header Control
public:
	long SearchHeaderStrAdd(CString search,CListCtrl *srcListCtrl=NULL){
		CListCtrl *p=srcListCtrl; if(p==NULL) p= pListCtrl;
		CString s;
		int i,n;
		n = GetHeaderCount(p);
		for(i=0;i<n;i++){ GetHeaderText(i,s,p); if(strcmpi(s,search)==0)break; }
		if(i==n)return -1; // not found
		return i;
	};
public:
	long CopyAllHeader(CListCtrl *srcListCtrl){
		long i,nHeaders;
		DeleteAllHeader(); nHeaders = GetHeaderCount(srcListCtrl);
		for(i=0;i<nHeaders;i++){CString s; GetHeaderText(i,s,srcListCtrl);	InsertHeader(i,s,srcListCtrl->GetColumnWidth(i));} // header
		return nHeaders;
	};
	long CopyHeaderTableToComboBox(CComboBox *pCombo,LPSTR Select="",LPSTR defstr="[I]",BOOL bCheck=FALSE){
		long i,j,k,nHeaders,d; BOOL bFound=FALSE;
		pCombo->ResetContent(); nHeaders = GetHeaderCount();
		k = pListCtrl->GetItemCount();
		for(i=0;i<nHeaders;i++){
			CString s; GetHeaderText(i,s);
			if(bCheck==TRUE){
				CString s;
				for(j=0;j<k;j++){s = pListCtrl->GetItemText(j,i); if(s.GetLength()!=0)break;}
				if(j==k) continue;
			}
			pCombo->SetItemData(d=pCombo->AddString(s),i);
			if(strcmp(Select,s)==0) {pCombo->SetCurSel(d); bFound=TRUE;}
		} // header
		pCombo->SetItemData(d=pCombo->AddString(defstr),-1); if(bFound==FALSE) pCombo->SetCurSel(d);
		return nHeaders;
	}
	long CopyHeaderTableToListBox(CListBox *pList,LPSTR Select="",LPSTR defstr="[I]",BOOL bCheck=FALSE){
		long i,j,k,nHeaders,d; BOOL bFound=FALSE;
		pList->ResetContent(); nHeaders = GetHeaderCount();
		k = pListCtrl->GetItemCount();
		for(i=0;i<nHeaders;i++){
			CString s; GetHeaderText(i,s);
			if(bCheck==TRUE){
				CString s;
				for(j=0;j<k;j++){s = pListCtrl->GetItemText(j,i); if(s.GetLength()!=0)break;}
				if(j==k) continue;
			}
			pList->SetItemData(d=pList->AddString(s),i); 
			if(strcmp(Select,s)==0) {pList->SetCurSel(d); bFound=TRUE;}
		} // header
		pList->SetItemData(d=pList->AddString(defstr),-1); if(bFound==FALSE) pList->SetCurSel(d);
		return nHeaders;
	}
	BOOL GetHeaderText		(int iNum,CString &sRet,CListCtrl *srcListCtrl=NULL){
		CHeaderCtrl* p;
		HDITEM hdi;
		TCHAR  lpBuffer[256];
		BOOL  b;
		if(srcListCtrl!=NULL)p = srcListCtrl->GetHeaderCtrl();
		else p = pListCtrl->GetHeaderCtrl();
		ZeroMemory(&hdi,sizeof(hdi));
		hdi.mask = HDI_TEXT;		hdi.pszText = lpBuffer;		hdi.cchTextMax = 256;
		b = p->GetItem(iNum, &hdi); 	if(b==TRUE)sRet = lpBuffer; else sRet="";
		return b;
	}
	long GetHeaderCount		(CListCtrl *plc=NULL)	{
		if(plc==NULL)	return ((CHeaderCtrl*)(pListCtrl->GetHeaderCtrl()))->GetItemCount();
		else			return ((CHeaderCtrl*)(plc->GetHeaderCtrl()))->GetItemCount();
	};
	void DeleteAllHeader	(CListCtrl *plc=NULL)	{if(plc!=NULL)	while(plc->DeleteColumn(0)==TRUE); else while(pListCtrl->DeleteColumn(0)==TRUE);	};
	void SetHDWindowLong	(DWORD dwNewStyle = HDS_HOTTRACK){ 
		CHeaderCtrl* p;
		p = pListCtrl->GetHeaderCtrl();
		::SetWindowLong(p->m_hWnd,GWL_STYLE,::GetWindowLong(p->m_hWnd,GWL_STYLE) | dwNewStyle );
	};
	//=====================================================================
	// List Control
public:
	BOOL GetItem(int nItem,int nSubItem,LPLVITEM buffer){
		ZeroMemory(buffer,sizeof(LVITEM));
		buffer->iItem = nItem;
		buffer->iSubItem = nSubItem;
		buffer->mask =LVIF_STATE | LVIF_TEXT | LVIF_PARAM|LVIF_INDENT|LVIF_IMAGE ;
		return pListCtrl->GetItem(buffer);
	};
	BOOL SetItem(int nItem,int nSubItem,LPLVITEM buffer){buffer->iItem = nItem; buffer->iSubItem = nSubItem;	return SetItem(buffer);	};
	BOOL SetItem(LPLVITEM buffer)						{return pListCtrl->SetItem(buffer);};
	//====================================================================
	// 
public:
	int IsSelected(int num){ return ((pListCtrl->GetItemState(num,LVIS_SELECTED)&LVIS_SELECTED)==0)?FALSE:TRUE; };
	int GetCurSelTop(void){	int d = -1,i,n;	n = pListCtrl->GetItemCount();for(i=0;i<n;i++){if( (pListCtrl->GetItemState(i,LVIS_SELECTED)&LVIS_SELECTED)!=0){d=i;break;}}return d;};
	int GetCurSelSecound(int &nSecound){
		int d = -1,i,n;	
		nSecound = -1;
		n = pListCtrl->GetItemCount();
		for(i=0;i<n;i++){
			if( (pListCtrl->GetItemState(i,LVIS_SELECTED)&LVIS_SELECTED)!=0){
				if(d==-1) d=i; else {nSecound = i;	break;}
			}
		}return d;};
public:
	int GetItemTextArray(int nNum,CString *strArray,CListCtrl *pList,int nOffset=0){
		int nFields = GetHeaderCount();
		for(int i=nOffset;i<nFields;i++){strArray[i-nOffset] = pList->GetItemText(nNum,i); } 
		return nFields-nOffset;
	};
	int GetItemTextArray(int nNum,CString *strArray,int nOffset=0){
		int nFields = GetHeaderCount();
		for(int i=nOffset;i<nFields;i++){strArray[i-nOffset] = pListCtrl->GetItemText(nNum,i); } 
		return nFields-nOffset;	
	};
public:
	DWORD SetExtendedStyle(DWORD dwNewStyle = LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT ){ 	return pListCtrl->SetExtendedStyle(dwNewStyle);}; 		// LVS_EX_CHECKBOXES , LVS_EX_FULLROWSELECT , LVS_EX_GRIDLINES
public: // status
	void Select			(long nIndex,BOOL bSel=TRUE){pListCtrl->SetItemState(nIndex,(bSel==FALSE)?0:LVIS_SELECTED,LVIS_SELECTED);};	//	pListCtrl->SetItemState(nIndex,(bSel==FALSE)?0:LVIS_SELECTED|LVIF_STATE,LVIS_SELECTED | LVIF_STATE);
	void SelectClear	(void){	long i,n;for(n = pListCtrl->GetItemCount(),i=0;i<n;i++)this->Select(i,FALSE);	};
	void SelectOne		(long nIndex,BOOL bSel=TRUE){	this->SelectClear(); this->Select(nIndex,bSel);	}
public: // data set support (column/lines)
	int SetTextArrayWithImage	(int nImage,int nIndex,int count,CString *strArray){
		LPCTSTR p;
		int i;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		for(i=0;i<count;i++){
			p = strArray[i];
			if(p==NULL) continue;
			lv.mask =  LVIF_TEXT| LVIF_IMAGE; lv.iImage = nImage;	lv.iSubItem =i; lv.pszText =(LPSTR)p;
			pListCtrl->SetItem(&lv);lv.iItem =nIndex;
		}
		return nIndex;
	};
	int SetTextWithImage(int nImage,int nIndex,int count,...){
		LPCTSTR p;
		int i,num=nIndex;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		lv.iImage = nImage;
		va_list argList;
		va_start(argList, count);
		for(i=0;i<count;i++){
			p = (LPCTSTR)va_arg(argList, LPCTSTR ); if(p==NULL) continue;
			lv.mask =  LVIF_TEXT| LVIF_IMAGE; lv.iSubItem =i; lv.pszText =(LPSTR)p;
			pListCtrl->SetItem(&lv);
		}
		va_end(argList); return num;
	};
	int SetTextArray	(int nIndex,int count,CString *strArray){
		LPCTSTR p;
		int i;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		for(i=0;i<count;i++){
			p = strArray[i];if(p==NULL) continue;
			lv.mask =  LVIF_TEXT; lv.iSubItem =i; lv.pszText =(LPSTR)p;
			pListCtrl->SetItem(&lv);lv.iItem =nIndex;
		}
		return nIndex;
	};
	int SetText(int nIndex,int count,...){
		LPCTSTR p;
		int i,num=nIndex;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex; va_list argList;
		va_start(argList, count);
		for(i=0;i<count;i++){
			p = (LPCTSTR)va_arg(argList, LPCTSTR ); if(p==NULL) continue;
			lv.mask =  LVIF_TEXT; lv.iSubItem =i; lv.pszText =(LPSTR)p;	pListCtrl->SetItem(&lv);
		}
		va_end(argList); return num;
	};
private:
	int nInsertMask;
public:
	void SetInsertTextMask(int nMask=LVIF_TEXT){nInsertMask=nMask;};
	int InsertTextArrayWithImage(int nImage,int nIndex,int count,CString *strArray){
		LPCTSTR p;
		int i,num;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		for(i=0;i<count;i++){
			p = strArray[i];	if(p==NULL) continue;
			lv.mask =  LVIF_TEXT | LVIF_IMAGE;
			lv.iSubItem =i; lv.pszText =(LPSTR)p;	lv.iImage = nImage;
			if(i==0)num = pListCtrl->InsertItem(&lv);else pListCtrl->SetItem(&lv);
			lv.iItem =num;
		}
		return num;
	};
	int InsertTextWithImage		(int nImage,int nIndex,int count,...){
		LPCTSTR p;
		int i,num;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		va_list argList;
		va_start(argList, count);
		for(i=0;i<count;i++){
			p = (LPCTSTR)va_arg(argList, LPCTSTR ); if(p==NULL) continue;
			lv.mask =  LVIF_TEXT| LVIF_IMAGE;
			lv.iImage = nImage; lv.iSubItem =i; lv.pszText =(LPSTR)p;
			if(i==0)num = pListCtrl->InsertItem(&lv);else pListCtrl->SetItem(&lv);
			lv.iItem =num;
		}
		va_end(argList); return num;
	};

	int InsertTextArray	(int nIndex,int count,CString *strArray){
		LPCTSTR p;
		int i,num;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		for(i=0;i<count;i++){
			p = strArray[i];	if(p==NULL) continue;
			lv.mask =  LVIF_TEXT;	lv.iSubItem =i; lv.pszText =(LPSTR)p;
			if(i==0)num = pListCtrl->InsertItem(&lv);else /*num =*/pListCtrl->SetItem(&lv);
			lv.iItem=num;
		}
		return num;
	};
	int InsertText		(int nIndex,int count,...){
		LPCTSTR p;
		int i,num;
		LVITEM lv;
		ZeroMemory(&lv,sizeof(lv));
		lv.iItem = nIndex;
		va_list argList;
		va_start(argList, count);
		for(i=0;i<count;i++){
			p = (LPCTSTR)va_arg(argList, LPCTSTR ); if(p==NULL) continue;
			lv.mask = LVIF_TEXT; lv.iSubItem =i; lv.pszText =(LPSTR)p;
			if(i==0)num = pListCtrl->InsertItem(&lv);else pListCtrl->SetItem(&lv);
			lv.iItem =num;
		}
		va_end(argList); return num;
	};
public: // header control support
	int InsertHeader(LPCTSTR str,int size=-1){
		LVCOLUMN pColumn;
		ZeroMemory(&pColumn,sizeof(pColumn));
		if(size==-1)size=(int)((strlen(str)+1)*lpMetrics.tmAveCharWidth);
		pColumn.mask = LVCF_TEXT | LVCF_WIDTH;	pColumn.fmt = LVCFMT_LEFT;		pColumn.pszText = (LPSTR)str;	pColumn.cx = size;	if(pListCtrl==NULL) return -1;
		return pListCtrl->InsertColumn( GetHeaderCount() ,&pColumn);
	};
	int InsertHeader(int nIndex,LPCTSTR str,int size=-1){
		LVCOLUMN pColumn;
		ZeroMemory(&pColumn,sizeof(pColumn));
		if(size==-1)size=(int)((strlen(str)+1)*lpMetrics.tmAveCharWidth);
		pColumn.mask = LVCF_TEXT | LVCF_WIDTH;	pColumn.fmt = LVCFMT_LEFT;	pColumn.pszText = (LPSTR)str;	pColumn.cx = size;	if(pListCtrl==NULL) return -1;
		return pListCtrl->InsertColumn(nIndex,&pColumn);
	};
public: // initialyzation
	void Attach(CListCtrl *pListCtrlLocal){ 
		pListCtrl = pListCtrlLocal;
		CDC *pDC = pListCtrl->GetDC();
		if(pDC!=NULL){pDC->GetTextMetrics(&lpMetrics); pListCtrl->ReleaseDC(pDC);}
	};
	CListCtrlSup(){	pListCtrl=NULL; ZeroMemory(&lpMetrics,sizeof(lpMetrics)); SetInsertTextMask(); };
	virtual ~CListCtrlSup(){};
public: // Edit sheet Like
	CEdit* EditLabel(NMHDR *pNMHDR,RECT*rc=NULL)						{LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR); return EditLabel(pNMLV->iItem,pNMLV->iSubItem,rc);};
	CEdit* EditLabel(NMHDR *pNMHDR,CListCtrl *pListCtrl,RECT*rc=NULL)	{LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR); return EditLabel(pNMLV->iItem,pNMLV->iSubItem,pListCtrl,rc);	};
	CEdit* EditLabel(int nItem,int nSubItem,RECT*rc=NULL)				{return EditLabel(nItem,nSubItem,pListCtrl,rc);	};
	CEdit* EditLabel(int nItem,int nSubItem,CListCtrl *pListCtrl,RECT*rc=NULL){
		CEdit *pEdit;
		pEdit=pListCtrl->EditLabel(nItem);
		if(pEdit!=NULL){
			RECT rcClient,rcwParent,rcwClient;
			LVCOLUMN col;
			int width;
			pEdit->SetWindowText(pListCtrl->GetItemText(nItem,nSubItem));	// TuACeeLXgRs[
			pEdit->SetSel(0,0);
			pEdit->SetSel(0,-1);
			//
			pEdit->GetClientRect(&rcClient);	// E̎擾
			pEdit->GetWindowRect(&rcwClient);
			pListCtrl->GetWindowRect(&rcwParent);
			//
			ZeroMemory(&col,sizeof(col));
			col.mask = LVCF_WIDTH;
			pListCtrl->GetColumn(nSubItem, &col);
			width = col.cx;
			for(int i=0;i<nSubItem;i++){
				LVCOLUMN col;
				ZeroMemory(&col,sizeof(col));
				col.mask = LVCF_WIDTH;
				pListCtrl->GetColumn(i, &col);
				rcwClient.left+=col.cx;
			}
			//
			if(rc!=NULL){
				rc->left	= rcwClient.left-rcwParent.left-3;
				rc->top		= rcwClient.top-rcwParent.top-3;
				rc->right	= width;
				rc->bottom	= rcClient.bottom;
			}
			pEdit->MoveWindow(rcwClient.left-rcwParent.left-3,
				rcwClient.top-rcwParent.top-3,
				width,rcClient.bottom);
		}
		return pEdit;
	};
public:
	int GetFontHeight(void){return lpMetrics.tmHeight;};	// \tHg̍擾
	int GetFontAveWidth(void){return lpMetrics.tmAveCharWidth;};	// \tHg̕ϕ擾
	int GetRectHeight(int nLine=0){RECT rc1; pListCtrl->GetItemRect(nLine,&rc1,LVIR_BOUNDS); return rc1.bottom-rc1.top;}; // \s̍擾
	int GetRectWidth(int nLine=0){RECT rc1; pListCtrl->GetItemRect(nLine,&rc1,LVIR_BOUNDS); return rc1.right-rc1.left;}; // \s̕擾
	BOOL ScrollPos(int nLine){CSize cs; POINT point; pListCtrl->GetItemPosition(nLine,&point); cs.cy = point.y - GetRectHeight(nLine);	cs.cx = 0; 	return pListCtrl->Scroll(cs);	}; // wsɃXN[(Œ荂vZ)
	BOOL ScrollPosAuto(int nLine){int nx =nLine; if(nx<0)nx=1; while(ScrollPos(nx)==FALSE){nx--; if(nx<0)break;} return (nx<0)?FALSE:TRUE;}; // wsɃXN[(Œ荂vZ)͈͓XN[
	CListCtrl * GetListCtrl(void){return pListCtrl;};
private:
	TEXTMETRIC lpMetrics;
	CListCtrl *pListCtrl;
};
#endif // __KLIB_CLISTCTRLSUPPORTCLASS__
